% This programme is written by Dr. Rajib Kumar Bhattacharjya of Department
% of Civil Engineering, Indian Institute of Technology Guwahati to
% demonstrate 1+1 ES

fileName = 'fitness';
x0 = [1 1]; % Starting point or initial solution
sigma = 2; % Define sigma value 
imax = 5000; % maximum iteration
k =0; % An counter
success =0; % Success counter
[n m] = size(x0); 
% x11 =x0; % x11 will store solution of all the iteration
for j=1:imax % The program will terminate after 3000 iteration
    k=k+1;
for i =1:m
    f0 = feval(fileName, x0); % objfunc will calculate the objective function value
    x1 = x0;
    x1(i) =x0(i)*randn(1)*sigma; % Will generate a new solution
    f1 = feval(fileName,x1);
    if (f1<f0)
        x0 = x1;
        success = success+1;
    end
%     x11 = [x11; x0];
end

% Updating sigma value as per Rechenberg postulate after every 20
% iterations
if(k==20)
    if(success/k>1/5)
        sigma = sigma/0.817;
    else
        sigma = sigma*0.817;
    end
    k=0;
    success =0;
end
disp(['Optimal solution X=   ', num2str(x0)]); 
disp(['Optimal function value f=   ', num2str(f0)]);
end

